Index: /java/ecj/framsticks/FramsticksUtils.java
===================================================================
--- /java/ecj/framsticks/FramsticksUtils.java	(revision 60)
+++ /java/ecj/framsticks/FramsticksUtils.java	(revision 61)
@@ -169,4 +169,7 @@
 				new RealValuedResult(testResult));
 	}
+	
+	private static float chasingBest = 2.0f;
+	private static float chasedBest = 2.0f;
 
 	public Pair<? extends InteractionResult> coevolutionaryEvaluate(String candidate, String test,
@@ -180,9 +183,23 @@
 				settingsFile, filePath));
 		String evaluation = readFromFile(scriptsOutputPath);
+
+		float candidateResult = 0;
+		float testResult      = 0;
 		
-		// TODO: parse output from eval
-		// e.g. candidateResult = Float.parseFloat(evaluation.split("\t")[1]);
-		float candidateResult = 0;
-		float testResult = 0;		
+		try {
+			
+			String[] str = evaluation.split("\n");
+			candidateResult = Float.parseFloat(str[0].split("\t")[1]); //chasing
+			testResult      = Float.parseFloat(str[1].split("\t")[1]); //chased
+			
+			chasingBest = ((candidateResult < chasingBest)?(candidateResult):(chasingBest));
+			chasedBest  = ((chasedBest      < testResult )?(chasedBest     ):(testResult));
+			
+			System.out.printf("%7.4f %7.4f --> %7.4f %7.4f\n", candidateResult, chasingBest, testResult, chasedBest);
+		}
+		catch(Exception ex) {
+			
+			System.out.println(scriptsOutputPath + " in bad format. There must be 2 lines with results.");
+		}
 
 		return new Pair<RealValuedResult>(new RealValuedResult(candidateResult),
Index: /java/ecj/framsticks/frams_coevolution3.params
===================================================================
--- /java/ecj/framsticks/frams_coevolution3.params	(revision 61)
+++ /java/ecj/framsticks/frams_coevolution3.params	(revision 61)
@@ -0,0 +1,80 @@
+verbosity = 0
+
+breedthreads  = 1
+evalthreads   = 1
+seed.0        = 4357
+
+pop     = ec.Population
+state   = ec.simple.SimpleEvolutionState
+init    = ec.simple.SimpleInitializer
+finish  = ec.simple.SimpleFinisher
+breed   = ec.simple.SimpleBreeder
+stat    = ec.simple.SimpleStatistics
+exch    = ec.simple.SimpleExchanger
+eval    = cecj.eval.SimpleCoevolutionaryEvaluator
+
+generations           = 200
+quit-on-run-complete  = true
+checkpoint            = false
+prefix                = ec
+checkpoint-modulo     = 1
+
+pop.subpops     = 2
+pop.subpop.0    = ec.Subpopulation
+pop.subpop.1    = ec.Subpopulation
+
+pop.subpop.0.size = 8
+pop.subpop.1.size = 8
+pop.subpop.0.duplicate-retries  = 0
+pop.subpop.1.duplicate-retries  = 0
+
+pop.subpop.0.species            = framsticks.FramsticksSpecies
+pop.subpop.0.species.ind        = framsticks.FramsticksIndividual
+pop.subpop.0.species.fitness    = ec.simple.SimpleFitness
+pop.subpop.0.species.crossover-prob = 1.0
+pop.subpop.0.species.mutation-prob  = 0.1
+pop.subpop.0.species.ind.init-type  = 0 
+
+pop.subpop.1.species            = framsticks.FramsticksSpecies
+pop.subpop.1.species.ind        = framsticks.FramsticksIndividual
+pop.subpop.1.species.fitness    = ec.simple.SimpleFitness
+pop.subpop.1.species.crossover-prob = 1.0
+pop.subpop.1.species.mutation-prob  = 0.1
+pop.subpop.1.species.ind.init-type  = 1 
+
+pop.subpop.0.species.pipe                   = framsticks.FramsticksMutationPipeline
+pop.subpop.0.species.pipe.source.0          = framsticks.FramsticksCrossoverPipeline
+pop.subpop.0.species.pipe.source.0.source.0 = ec.select.TournamentSelection
+pop.subpop.0.species.pipe.source.0.source.1 = ec.select.TournamentSelection
+
+pop.subpop.1.species.pipe                   = framsticks.FramsticksMutationPipeline
+pop.subpop.1.species.pipe.source.0          = framsticks.FramsticksCrossoverPipeline
+pop.subpop.1.species.pipe.source.0.source.0 = ec.select.TournamentSelection
+pop.subpop.1.species.pipe.source.0.source.1 = ec.select.TournamentSelection
+
+select.tournament.size = 2
+
+eval.problem                  = framsticks.FramsticksCoevolutionaryProblem
+eval.interaction-scheme       = cecj.interaction.LearnerTeacherInteractionScheme
+
+eval.interaction-scheme.subpop.0.role  = TEACHER 
+eval.interaction-scheme.subpop.1.role  = LEARNER 
+
+eval.subpop.0.sampling-method = cecj.sampling.AllSamplingMethod
+eval.subpop.0.fitness-method  = cecj.fitness.SimpleSumFitness
+eval.subpop.1.sampling-method = cecj.sampling.AllSamplingMethod
+eval.subpop.1.fitness-method  = cecj.fitness.SimpleSumFitness
+
+breed.elite.0 = 2
+breed.elite.1 = 2
+
+stat.file = $out.stat
+
+framsticks.debug = false
+framsticks.directory-path = C:/Users/mszubert/Framsticks31rc4/
+framsticks.scripts-output = C:/Users/mszubert/Framsticks31rc4/scripts_output/genosEval.txt
+framsticks.settings-file = C:/Users/mszubert/Framsticks31rc4/pursuit.sim
+framsticks.working-directory = C:/Users/mszubert/Framsticks31rc4/
+framsticks.expdef = pursuit
+framsticks.executable-cmd = frams -Q -e -s -icliutils.ini
+