Index: cpp/gdk/conv_f1.cpp
===================================================================
--- cpp/gdk/conv_f1.cpp	(revision 64)
+++ cpp/gdk/conv_f1.cpp	(revision 66)
Index: cpp/gdk/conv_f1.h
===================================================================
--- cpp/gdk/conv_f1.h	(revision 64)
+++ cpp/gdk/conv_f1.h	(revision 66)
Index: cpp/gdk/defgenoconv.cpp
===================================================================
--- cpp/gdk/defgenoconv.cpp	(revision 64)
+++ cpp/gdk/defgenoconv.cpp	(revision 66)
@@ -59,5 +59,5 @@
 #ifdef USE_GENCONV_F81
 GenoConv_F8ToF1 *gc81=new GenoConv_F8ToF1();
-GenoConv_F8ToF1::staticpar=gc81->par; //a trick so that the simulator can see this parama
+GenoConv_F8ToF1::staticpar=gc81->par; //a trick so that the simulator can see this param
 addConverter(gc81);
 #endif
Index: cpp/gdk/errmanager.cpp
===================================================================
--- cpp/gdk/errmanager.cpp	(revision 64)
+++ cpp/gdk/errmanager.cpp	(revision 66)
Index: cpp/gdk/errmanager.h
===================================================================
--- cpp/gdk/errmanager.h	(revision 64)
+++ cpp/gdk/errmanager.h	(revision 66)
Index: cpp/gdk/extvalue.cpp
===================================================================
--- cpp/gdk/extvalue.cpp	(revision 64)
+++ cpp/gdk/extvalue.cpp	(revision 66)
Index: cpp/gdk/extvalue.h
===================================================================
--- cpp/gdk/extvalue.h	(revision 64)
+++ cpp/gdk/extvalue.h	(revision 66)
Index: cpp/gdk/f0-modeldef.m4
===================================================================
--- cpp/gdk/f0-modeldef.m4	(revision 64)
+++ cpp/gdk/f0-modeldef.m4	(revision 66)
Index: cpp/gdk/f0.def
===================================================================
--- cpp/gdk/f0.def	(revision 64)
+++ cpp/gdk/f0.def	(revision 66)
Index: cpp/gdk/f0classes.h
===================================================================
--- cpp/gdk/f0classes.h	(revision 64)
+++ cpp/gdk/f0classes.h	(revision 66)
Index: cpp/gdk/f0def.xml
===================================================================
--- cpp/gdk/f0def.xml	(revision 64)
+++ cpp/gdk/f0def.xml	(revision 66)
Index: cpp/gdk/f0defxml.m4
===================================================================
--- cpp/gdk/f0defxml.m4	(revision 64)
+++ cpp/gdk/f0defxml.m4	(revision 66)
Index: cpp/gdk/gdktest.cpp
===================================================================
--- cpp/gdk/gdktest.cpp	(revision 64)
+++ cpp/gdk/gdktest.cpp	(revision 66)
Index: cpp/gdk/geno.cpp
===================================================================
--- cpp/gdk/geno.cpp	(revision 64)
+++ cpp/gdk/geno.cpp	(revision 66)
Index: cpp/gdk/genoconv.cpp
===================================================================
--- cpp/gdk/genoconv.cpp	(revision 64)
+++ cpp/gdk/genoconv.cpp	(revision 66)
Index: cpp/gdk/genoconv.h
===================================================================
--- cpp/gdk/genoconv.h	(revision 64)
+++ cpp/gdk/genoconv.h	(revision 66)
Index: cpp/gdk/model.cpp
===================================================================
--- cpp/gdk/model.cpp	(revision 64)
+++ cpp/gdk/model.cpp	(revision 66)
Index: cpp/gdk/model.def
===================================================================
--- cpp/gdk/model.def	(revision 64)
+++ cpp/gdk/model.def	(revision 66)
Index: cpp/gdk/model.h
===================================================================
--- cpp/gdk/model.h	(revision 64)
+++ cpp/gdk/model.h	(revision 66)
Index: cpp/gdk/modelparts.cpp
===================================================================
--- cpp/gdk/modelparts.cpp	(revision 64)
+++ cpp/gdk/modelparts.cpp	(revision 66)
Index: cpp/gdk/modelparts.h
===================================================================
--- cpp/gdk/modelparts.h	(revision 64)
+++ cpp/gdk/modelparts.h	(revision 66)
Index: cpp/gdk/multiparamload.cpp
===================================================================
--- cpp/gdk/multiparamload.cpp	(revision 64)
+++ cpp/gdk/multiparamload.cpp	(revision 66)
Index: cpp/gdk/neurocls-factory.h
===================================================================
--- cpp/gdk/neurocls-factory.h	(revision 64)
+++ cpp/gdk/neurocls-factory.h	(revision 66)
Index: cpp/gdk/neurocls-library.h
===================================================================
--- cpp/gdk/neurocls-library.h	(revision 64)
+++ cpp/gdk/neurocls-library.h	(revision 66)
Index: cpp/gdk/neurocls-library.m4
===================================================================
--- cpp/gdk/neurocls-library.m4	(revision 64)
+++ cpp/gdk/neurocls-library.m4	(revision 66)
Index: cpp/gdk/neurofactory.cpp
===================================================================
--- cpp/gdk/neurofactory.cpp	(revision 64)
+++ cpp/gdk/neurofactory.cpp	(revision 66)
Index: cpp/gdk/neuroimpl.cpp
===================================================================
--- cpp/gdk/neuroimpl.cpp	(revision 64)
+++ cpp/gdk/neuroimpl.cpp	(revision 66)
Index: cpp/gdk/neuroimpl.h
===================================================================
--- cpp/gdk/neuroimpl.h	(revision 64)
+++ cpp/gdk/neuroimpl.h	(revision 66)
Index: cpp/gdk/nonstd.h
===================================================================
--- cpp/gdk/nonstd.h	(revision 64)
+++ cpp/gdk/nonstd.h	(revision 66)
Index: cpp/gdk/nonstd_io.h
===================================================================
--- cpp/gdk/nonstd_io.h	(revision 64)
+++ cpp/gdk/nonstd_io.h	(revision 66)
Index: cpp/gdk/sstringutils.cpp
===================================================================
--- cpp/gdk/sstringutils.cpp	(revision 64)
+++ cpp/gdk/sstringutils.cpp	(revision 66)
Index: cpp/gdk/sstringutils.h
===================================================================
--- cpp/gdk/sstringutils.h	(revision 64)
+++ cpp/gdk/sstringutils.h	(revision 66)