Index: java/client_3D/static/shared/res/shaders/old_diffuse_light.glsl
===================================================================
--- java/client_3D/static/shared/res/shaders/old_diffuse_light.glsl	(revision 66)
+++ 	(revision )
@@ -1,32 +1,0 @@
-//name diffuse_light
-//vert
-varying vec3 ecPos;
-varying vec3 ecNormal;			
-void main()
-{	
-	gl_Position = gl_ProjectionMatrix * gl_ModelViewMatrix * gl_Vertex;
-	gl_TexCoord[0].st = gl_MultiTexCoord0.ts;
-	ecNormal = gl_NormalMatrix * gl_Normal;
-	vec4 ecPos4 = gl_ModelViewMatrix * gl_Vertex;
-	ecPos = ecPos4.xyz/ecPos4.w;
-}
-
-//frag
-uniform sampler2D diffuseMap;
-varying vec3 ecPos;
-varying vec3 ecNormal;
-vec3 ecEye;
-vec3 ecLight;
-
-float diffuse(int lightId)
-{
-	ecLight = gl_LightSource[lightId].position.xyz - ecPos;
-	return max(0.2, dot(normalize(ecNormal), normalize(ecLight)));
-}
-
-void main()
-{					
-	ecEye = normalize(-ecPos);				
-	gl_FragColor = diffuse(0) * texture2D(diffuseMap, gl_TexCoord[0].st);
-}
-
Index: java/client_3D/static/shared/res/shaders/old_fur.glsl
===================================================================
--- java/client_3D/static/shared/res/shaders/old_fur.glsl	(revision 66)
+++ 	(revision )
@@ -1,38 +1,0 @@
-//name fur
-//vert
-uniform float scale;
-varying vec3 ecPos;
-varying vec3 ecNormal;			
-void main()
-{	
-	vec4 vert = gl_Vertex + vec4(gl_Normal.x*scale, gl_Normal.y*scale, gl_Normal.z*scale, 0);
-	gl_Position = gl_ProjectionMatrix * gl_ModelViewMatrix * vert;
-	gl_TexCoord[0].st = gl_MultiTexCoord0.ts;
-	gl_TexCoord[0].st *= 0.25;
-	ecNormal = gl_NormalMatrix * gl_Normal;
-	vec4 ecPos4 = gl_ModelViewMatrix * gl_Vertex;
-	ecPos = ecPos4.xyz/ecPos4.w;
-}
-
-//frag
-uniform sampler2D diffuseMap;
-uniform sampler2D furMap;
-varying vec3 ecPos;
-varying vec3 ecNormal;
-vec3 ecEye;
-vec3 ecLight;
-
-float diffuse(int lightId)
-{
-	ecLight = gl_LightSource[lightId].position.xyz - ecPos;
-	return max(0.2, dot(normalize(ecNormal), normalize(ecLight)));
-}
-
-void main()
-{					
-	ecEye = normalize(-ecPos);	
-	vec3 alpha = texture2D(furMap, vec2(gl_TexCoord[0].s * 2.0, gl_TexCoord[0].t * 2.0)).xyz;
-	if (alpha.r + alpha.g + alpha.b < 1.5) discard;			
-	gl_FragColor = diffuse(0) * texture2D(diffuseMap, gl_TexCoord[0].st);;
-}
-
Index: java/client_3D/static/shared/res/shaders/old_normal_mapping.glsl
===================================================================
--- java/client_3D/static/shared/res/shaders/old_normal_mapping.glsl	(revision 66)
+++ 	(revision )
@@ -1,67 +1,0 @@
-//vert
-	
-varying vec3 lightVec; 
-varying vec3 eyeVec;
-varying vec2 texCoord;
-attribute vec3 tangent; 
-					 
-
-void main(void)
-{
-	gl_Position = ftransform();
-	texCoord = gl_MultiTexCoord0.xy * 0.4;
-	
-	vec3 n = normalize(gl_NormalMatrix * gl_Normal);
-	vec3 t = normalize(gl_NormalMatrix * tangent);
-	vec3 b = cross(n, t);
-	
-	vec3 vVertex = vec3(gl_ModelViewMatrix * gl_Vertex);
-	vec3 tmpVec = gl_LightSource[0].position.xyz - vVertex;
-
-	lightVec.x = dot(tmpVec, t);
-	lightVec.y = dot(tmpVec, b);
-	lightVec.z = dot(tmpVec, n);
-
-	tmpVec = -vVertex;
-	eyeVec.x = dot(tmpVec, t);
-	eyeVec.y = dot(tmpVec, b);
-	eyeVec.z = dot(tmpVec, n);
-}
-	
-//frag
-
-varying vec3 lightVec;
-varying vec3 eyeVec;
-varying vec2 texCoord;
-uniform sampler2D diffuseMap;
-uniform sampler2D normalMap;
-//uniform float invRadius;
-
-void main (void)
-{
-	float invRadius = 0.2;
-	
-	float distSqr = dot(lightVec, lightVec);
-	float att = clamp(1.0 - invRadius * sqrt(distSqr), 0.0, 1.0);
-	vec3 lVec = lightVec * inversesqrt(distSqr);
-
-	vec3 vVec = normalize(eyeVec);
-	
-	vec4 base = texture2D(diffuseMap, texCoord);
-	
-	vec3 bump = normalize( texture2D(normalMap, texCoord).xyz * 2.0 - 1.0);
-
-	vec4 vAmbient = vec4(0.8, 0.5, 0.2, 0.0);//gl_LightSource[0].ambient * gl_FrontMaterial.ambient;
-
-	float diffuse = max( dot(lVec, bump), 0.0 );
-	
-	vec4 vDiffuse = gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse * diffuse;	
-
-	float specular = pow(clamp(dot(reflect(-lVec, bump), vVec), 0.0, 1.0), gl_FrontMaterial.shininess );
-	
-	vec4 vSpecular = gl_LightSource[0].specular * gl_FrontMaterial.specular * specular;	
-	
-	gl_FragColor = ( vAmbient*base + 
-					 vDiffuse*base + 
-					 vSpecular) * att;
-}
Index: java/client_3D/static/shared/res/shaders/old_stone.glsl
===================================================================
--- java/client_3D/static/shared/res/shaders/old_stone.glsl	(revision 66)
+++ 	(revision )
@@ -1,27 +1,0 @@
-//name stone
-//vert
-	
-varying vec2 texCoord;
-varying vec3 normalVec; 
-
-void main(void)
-{
-	gl_Position = ftransform();
-	texCoord = gl_MultiTexCoord0.xy * 0.4;
-	normalVec = normalize(gl_NormalMatrix * gl_Normal);
-}
-	
-//frag
-
-varying vec2 texCoord;
-uniform sampler2D diffuseMap;
-varying vec3 normalVec;
-
-void main (void)
-{
-	vec4 base = texture2D(diffuseMap, texCoord);
-	
-	float c = dot(normalVec, vec3(0,0,-1));
-	c = abs(c);
-	gl_FragColor = base * (1.0-c);
-}